import { watch as d, onMounted as m, ref as c, unref as g, watchEffect as p, onUpdated as S, reactive as W, isReactive as R, toRaw as I, toRefs as P, toRef as T, getCurrentInstance as C, onUnmounted as E, nextTick as O, onActivated as Q, readonly as b } from "vue";
import { cloneDeep as h, isObject as j, deepMerge as F, getSlotsProps as s, isFunction as A } from "@gx-design-vue/pro-utils";
function B(e, t, i) {
  d(t, (n, a) => {
    i ? i(n, a) && e() : e();
  }), m(() => {
    e();
  });
}
const w = (typeof window > "u" ? !1 : /iPad|iPhone|iPod/.test(navigator.platform) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) && !window.MSStream;
function G() {
  return w;
}
const K = typeof window > "u" ? !1 : w || window.safari !== void 0;
function H() {
  return K;
}
const f = {
  xs: {
    maxWidth: 575,
    matchMedia: "(max-width: 575px)"
  },
  sm: {
    minWidth: 576,
    maxWidth: 767,
    matchMedia: "(min-width: 576px) and (max-width: 767px)"
  },
  md: {
    minWidth: 768,
    maxWidth: 991,
    matchMedia: "(min-width: 768px) and (max-width: 991px)"
  },
  lg: {
    minWidth: 992,
    maxWidth: 1199,
    matchMedia: "(min-width: 992px) and (max-width: 1199px)"
  },
  xl: {
    minWidth: 1200,
    maxWidth: 1599,
    matchMedia: "(min-width: 1200px) and (max-width: 1599px)"
  },
  xxl: {
    minWidth: 1600,
    matchMedia: "(min-width: 1600px)"
  }
}, k = () => {
  let e = "md";
  return typeof window > "u" || (e = Object.keys(f).find((i) => {
    const { matchMedia: n } = f[i];
    return !!window.matchMedia(n).matches;
  })), e;
}, J = () => {
  const e = c(k());
  return Object.keys(f).forEach((t) => {
    const { matchMedia: i } = f[t], n = window.matchMedia(i);
    n.matches && (e.value = t), n.onchange = (a) => {
      a.matches && (e.value = t);
    };
  }), e;
};
function L(e, t, i) {
  const n = c(e());
  return d(t, (a, u) => {
    i ? i(a, u) && (n.value = e()) : n.value = e();
  }), n;
}
function q(e) {
  const t = typeof e == "function" ? e() : e, i = c(t);
  function n(a) {
    i.value = a;
  }
  return [i, n];
}
function X(e, t) {
  const { defaultValue: i, value: n = c() } = t || {};
  let a = typeof e == "function" ? e() : e;
  n.value !== void 0 && (a = g(n)), i !== void 0 && (a = typeof i == "function" ? i() : i);
  const u = c(a), o = c(a), [l, x] = q([o.value]);
  p(() => {
    let r = n.value !== void 0 ? n.value : u.value;
    t != null && t.postState && (r = t.postState(r, u.value)), o.value = r;
  }), d(l, () => {
    var v;
    const r = l.value[0];
    u.value !== r && ((v = t == null ? void 0 : t.onChange) == null || v.call(t, u.value, r));
  }, { deep: !0 });
  function M(r) {
    u.value = r;
  }
  function y(r) {
    M(r), x([o.value]);
  }
  return d(n, () => {
    u.value = n.value;
  }), [o, y, u];
}
function Y(e, t) {
  const i = c(e[t]);
  return S(() => {
    const n = e[t];
    i.value !== n && (i.value = n);
  }), i;
}
function Z(e, t) {
  const i = typeof e == "function" ? e() : e, n = W({
    data: R(i) ? h(I(i)) : h(i)
  });
  function a(u) {
    u && j(u) && (n.data = F(n.data, u, t));
  }
  return [P(T(n, "data").value), a];
}
function _(e, t, i, n) {
  const a = c(s(e, t, i, n));
  return d(e.map((u) => () => i[u]), () => {
    a.value = s(e, t, i, n);
  }, { deep: 1 }), d(e.map((u) => () => {
    var o;
    return (o = t[u]) == null ? void 0 : o.call(t);
  }), () => {
    a.value = s(e, t, i, n);
  }, { deep: !0 }), a;
}
function D(e) {
  C() && E(e);
}
function $(e, t, i = !1) {
  if (!A(e))
    throw new Error("handle is not Function!");
  const { readyRef: n, stop: a, start: u } = N(t);
  return i ? e() : d(n, (o) => {
    o && e();
  }, { immediate: !1 }), { readyRef: n, stop: a, start: u };
}
function N(e) {
  const t = c(!1);
  let i;
  function n() {
    t.value = !1, i && window.clearTimeout(i);
  }
  function a() {
    n(), i = setTimeout(() => {
      t.value = !0;
    }, e);
  }
  return a(), D(n), { readyRef: t, stop: n, start: a };
}
function V(e) {
  let t;
  m(() => {
    e(!1), O(() => {
      t = !0;
    });
  }), Q(() => {
    t && e(!0);
  });
}
function ee() {
  const e = c(!1);
  return m(() => {
    e.value = !0;
  }), b(e);
}
export {
  V as onMountedOrActivated,
  D as tryOnUnmounted,
  B as useEffect,
  G as useIsIos,
  ee as useIsMounted,
  H as useIsSafari,
  J as useMediaQuery,
  L as useMemo,
  X as useMergedState,
  Y as usePickSlots,
  Z as useReactiveState,
  _ as useSlotsProps,
  q as useState,
  $ as useTimeout
};
